<template>
	<mind-layout-table :data="ListaLugares" rowKey="id" 
		:path="$route.path" @delete="onDelete" @filter="filtrar"
		>
			<template v-slot:filter="{form}">
				<el-row  >
					<el-col  :lg="12">
						<el-form-item label="Nombre">
							<el-input v-model="form.nombre"  />
						</el-form-item>
					</el-col>
					<el-col  :lg="12">
						<el-form-item label="Localidad">
							<el-input v-model="form.localidad"  />
						</el-form-item>
					</el-col>
					<el-col  :lg="12">
						<el-form-item label="Tipo">
							<el-select v-model="form.tipo">
								<el-option value="Lugar">Lugar</el-option>
								<el-option value="Calle">Calle</el-option>
							</el-select>
						</el-form-item>
					</el-col>
				</el-row>
			</template>
			<el-table-column sortable prop="nombre" label="Nombre"  />
			<el-table-column sortable prop="localidad" label="Localidad"  />
			<el-table-column sortable prop="tipo" label="Tipo"  />
			<el-table-column sortable prop="frecuente" label="Frecuente">
				<template slot-scope="scope">
					{{scope.row.frecuente ? 'Si': 'No'}}
				</template>
			</el-table-column>
	</mind-layout-table>
</template>

<script>
import store from '@/store/lugares'
import {Rest} from '@/../vendor/mind-core-web'

export default {
  async created() {
		store.idAgencia = 1

		this.api = new Rest({
			uri: `/api/viajes/agencias/${store.idAgencia}/lugares`, 
			state: store.data,
			key: 'id'})

		this.api.FetchAll().catch((error)=>{
			this.$message({
				showClose: true,
				type: 'error',
				message: error
			});
		})
	},
	computed:{
		/**
		 * Devuelve la lista de Clientes
		 */
		ListaLugares() {
			return store.data.RESOURCE_LIST || []
		},
	},
	methods: {
		/**
		 * Elimina el recuros especificado
		 * @param id recurso del elemento a eliminar
		 */
		onDelete(id){
			this.api.Delete(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},
		filtrar(filtros) {
			this.api.FetchAll({
				filters: filtros
			})
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})

			// console.log('filtrar', filtros)
		}
	},
	data() {
		return {
			api: null,
			filtroActivo: false,
		}
	}
	
}
</script>
